package benefactorkindboxreqservice

import (
	"context"
	paginationparam "git.gocasts.ir/ebhomengo/niki/param"
	param "git.gocasts.ir/ebhomengo/niki/param/benefactor/kind_box_req"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
)

func (s Service) GetAll(ctx context.Context, req param.GetAllRequest) (param.GetAllResponse, error) {
	const op = "adminkindboxreqservice.GetAllAwaitingDelivery"

	allKindBoxReq, total, err := s.repo.GetAllKindBoxReq(ctx, req.Filter, req.Pagination, req.Sort)
	if err != nil {

		return param.GetAllResponse{}, richerror.New(op).WithErr(err)
	}

	return param.GetAllResponse{
		AllKindBoxReq: allKindBoxReq,
		Pagination: paginationparam.PaginationResponse{
			PageSize:   req.Pagination.GetPageSize(),
			PageNumber: req.Pagination.GetPageNumber(),
			Total:      total,
		},
	}, nil
}
